<?php
header("cache-control: no-cache");
header("Content-Type: text/html; charset=UTF-8");
require_once "../../classes/settings.php"; 
require_once $CLASSES_ROOT . "odars/dao/resource/cresource.php";
require_once $CLASSES_ROOT . "odars/dao/Cusercollection.php";
require_once $CLASSES_ROOT . "odars/html/HTMLPreview.php";
require_once $CLASSES_ROOT . "odars/util/dir.php";
require_once $CLASSES_ROOT . "odars/util/messages.php";
require_once $CLASSES_ROOT . "odars/dao/resource/cresrelations.php";
require_once $CLASSES_ROOT . "odars/dao/cresourceresultset.php";
// Local include
include "navibar.php";


	$id = $_GET['id'];
	$version = 0;
	$show_versions = false;
	$position = -1;

	if(array_key_exists("ver", $_GET)){ 
		$version = $_GET['ver'];
		$show_versions = true;
	}

	// Check if resource is in list context
	if(array_key_exists("pos", $_GET)){ 
		$position = $_GET['pos'];
	}

	$resource = new CResource($DATABASE, $id);
	$keys = $resource->getKeywords();
  $dir=$resource->getPath();
	$latest_ver = $resource->getLatestVersionNumber();
	if($version == 0)
		$version = $latest_ver;

	$preview_file = $resource->getPreviewFileName($version);
	$files = $resource->getVersionFiles($version);
	
	// Check if file is in user collection
	$user_collection = new CUserCollection($DATABASE, $USER_NAME);
	$in_collection = $user_collection->isIn($id);

	// Get selected cateogires	
	$selected = $resource->getCategories();
	
	// Prepare restrictions
	$restrictions = array();
	$search_keywords = array();
	if(isset($_SESSION["search_keywords"])){
		$search_keywords = $_SESSION["search_keywords"];
		foreach($search_keywords as $sk){
			$restriction['type'] = "keyword";
			$restriction['data'] = trim($sk);
			array_push($restrictions, $restriction);
		}
	}
	
	$search_categories = array();
	if(isset($_SESSION["search_categories"])){
		$search_categories = $_SESSION["search_categories"];
		foreach($search_categories as $sc){
			$restriction['type'] = "category";
			$restriction['data'] = $sc;
			array_push($restrictions, $restriction);
		}
	}
	

	// Get resource relations
	$relations = new CResRelations($DATABASE, $id);
	$res_relations = $relations->getRelations();
	
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "XHTML1-t.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>View resource- <?= $resource->getName()?></title>
	<link rel="stylesheet" href="/common/default.css" type="text/css"/>
	<script type="text/javascript" language="JavaScript" src="/common/admin.js"></script>
</head>
<body>

<?php include "../header.php"; ?>
<?php 
	if($position >= 0)
	show_navibar($DATABASE, $restrictions, $position);
		
?>

<?php
	// show message if any given
	if(isset($_GET['msg'])){
		echo "<div class='message'>\n";
		echo $_messages[$_GET['msg']];
		echo "</div>\n";
	}
?>

<table width="100%">
<tr>
<td width="50%"> 
<table>
<tr>
	<td class="label">Preview:</td>
	<td>
		<?php
			$preview = new HTMLPreview($config['files_alias']);
			$preview->render($preview_file);
		?>
	</td>
</tr>
<tr>
	<td class="label" width="150">ID:</td>
	<td><?= $resource->getID();?></td>
</tr>
<tr>
	<td class="label">Name:</td>
	<td><?= htmlspecialchars($resource->getName());?></td>
</tr>
<tr>
	<td class="label">Native Name:</td>
	<td><?= htmlspecialchars($resource->getNativeName());?></td>
</tr>
<tr>
	<td class="label">Creator:</td>
	<td><?= $resource->getAuthor()?> </td>
</tr>
<tr>
	<td class="label">Entered:</td>
	<td><?= $resource->getCreationDate()?></td>
</tr>


<tr>
	<td class="label">Keywords:</td>
	<td>
		<?php
			$print_comma = false; 
			foreach($keys as $key){
				if($print_comma)
					echo ", ";  
				else
					$print_comma = true;

				if(in_array($key, $search_keywords))
					echo "<font color='red'><b>$key</b></font>";
				else				
					echo $key;
					
			} 
			
		?> 
	</td>
</tr>
<tr>
	<td class="label">Remarks:</td>
	<td><?= htmlspecialchars($resource->getRemarks());?> </td>
</tr>
<tr>
	<td class="label">Files Version:</td>
	<td>
		<?php 
			echo "<b> $version </b>  &nbsp;&nbsp;&nbsp;";
			if($show_versions){
				for ($vn=$latest_ver; $vn >= 1 ; $vn--) 
					if($vn == $version)
						echo " $vn ";
					else
						echo " <a href='view_resource.php?id=$id&ver=$vn'>$vn</a> ";
			}
			else{
				echo " <a href=\"view_resource.php?id=".$id."&ver=".$latest_ver."\">previous versions</a> ";
			}
		?>
	</td>
</tr>
<tr>
	<td class="label">Files:</td>
	<td>
	<table width="100%">
	<?php 
		foreach($files as $m){ 
			$fname = urlencode($m['path']."/".$m['name']);
			$file_size =  formatFileSize(filesize($config['files_path'].$m['path']."/".$m['name'])); 
			echo "<tr>\n";
			echo "<td><a href='../assets/view_file.php?id=$id&fname=$fname'>$m[name]</a></td>\n";
			echo "<td>$file_size</td>\n";
			echo "<td><a href='../assets/download.php?id=$id&fname=$fname'>download</a></td>\n";
			echo "</tr>\n";
		} // foreach 
	
	?>
	</table>
	</td>
</tr>
</table>
</td>

<td valign="top">

<div class="group_box"> 
<h2>Categories</h2>
<table width='100%'>
	<?php include dirname(__FILE__) . "/categories/resource_categories_view.php";?>
	<tr>
		<td align="right">
			<input type="button" value="Edit" onClick="location='categories/edit_categories.php?id=<?=$id?>';return false;"/>
		</td>
	</tr>
</table>
</div>

<div class="group_box"> 
<h2>Relations</h2> 
<table width="100%">
<?php

	// Show relations from this resource
	foreach($res_relations['from'] as $relation){
		echo "<tr>\n";
		echo "<td>This Resource <b>$relation[relation_name]</b></td>";
		echo "<td><a href='view_resource.php?id=$relation[resource]'>Resource $relation[resource]</a></td> ";
		echo "<tr>\n";
	}

	// Show relation to this resource
	foreach($res_relations['to'] as $relation){
		echo "<tr>\n";
		echo "<td><a href='view_resource.php?id=$relation[resource]'>Resource $relation[resource]</a></td> ";
		echo "<td><b>$relation[relation_name]</b> This resource</b></td>";
		echo "<tr>\n";
	}

?>
<tr>
	<td></td>
	<td align="right">
		<input type="button" value="Edit" onClick="location='relations/edit_relation.php?id=<?=$id?>';return false;"/>
	</td>
</tr>
</table>
</div>

</td>

<td bgcolor="#ffffcc" valign="top" align="right"> 

<p>
	<a href="edit_resource.php?id=<?=$id?>">Edit Description</a>
</p>
<p>
	<a href="version/edit_version_files.php?id=<?=$id?>">Add files</a>
</p>
<!--p>
	<a href="../tracker/create.php?res_id=<?=$id?>">Create new task</a>
</p-->

<p>
<?php
	if($in_collection){
		echo "In My Collection";
	}
	else{
		$location = "/browser/resource/view_resource.php?id=$id";
		echo "<a href='/browser/mycollection/add_resource_action.php?id=$id&location=$location'>";
		echo "Add to My Collection";
		echo "</a>\n";
	}
?>
</p>

</td>
</tr>
</table>
<?php include "$DOC_ROOT/common/footer.php"; ?>
</body>
</html>


