<?php
header("Content-Type: text/html; charset=UTF-8");
require_once "../classes/settings.php"; 
require_once $CLASSES_ROOT . "odars/dao/cresourceresultset.php";
require_once $CLASSES_ROOT . "odars/dao/ccategorytree.php";


$qs = "";
$q="";
if(array_key_exists("q", $_GET)){ 	
	$q = $_GET['q']; 
	$qs .="&q=".$q;
}

$count = 50;
if (isset($_GET['count'])) 
	$count = $_GET['count'];
$page = 1;

$search_keywords = array();
if(isset($_SESSION["search_keywords"])){
	$search_keywords = $_SESSION["search_keywords"];
}

$search_categories = array();
if(isset($_SESSION["search_categories"])){
	$search_categories = $_SESSION["search_categories"];
}
$restrictions = array();

foreach($search_keywords as $sk){
	$restriction['type'] = "keyword";
	$restriction['data'] = trim($sk);
	array_push($restrictions, $restriction);
}

foreach($search_categories as $sc){
	$restriction['type'] = "category";
	$restriction['data'] = $sc;
	array_push($restrictions, $restriction);
}

if (count($restrictions) > 0 )
	$result_set = new CResourceResultset($DATABASE, $restrictions);
else
 	header("location: index.php");


	
$gCount =  $result_set->getSize();
if ($gCount % $count >0)	$pages = ceil($gCount / $count); else	$pages = $gCount / $count;
if (isset($_GET['page'])) $page = $_GET['page'];
$from = ($page-1) * $count;


$resources = $result_set->getResources($from,$count);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "XHTML1-t.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Ramses</title>
	<meta name="keywords" content="ramses, search">
	<link rel="stylesheet" href="/common/default.css" type="text/css"/>
	<script type="text/javascript" language="JavaScript" src="/common/admin.js"></script>
</head>

<body>

<?php include "header.php"; ?>

<p>
<div align="center">
<form method="GET"  action="add_restriction_action.php">
	<input type="Text" name="q" size="60"/>
	<input type="submit" value="Search"/>
</form>
</div>
</p>

<table width = "100%">
    <tr>
      <td width="30%" valign="top"> <!-- left column with  categories --> 
		
<?php 
$category_tree = new CCategoryTree($DATABASE, $restrictions);
$root_categories = $category_tree->getRootNodes();

$selected_categories_parents = array();
foreach ($search_categories as $sc){
	$node = $category_tree->getNode($sc);
	$parents = $node['parents'];
	array_push($parents,$sc);
	
	$selected_categories_parents[$parents[0]] = $parents;
	$selected_categories[$sc] = $parents;
}

		foreach($root_categories as $top_level){
			$sub_nodes = $top_level['nodes'];
			$category_id = $top_level['id'];
			$category_header = $top_level['name']." ";
			
			if (isset( $selected_categories_parents[$category_id])) {
				$parents_path = $selected_categories_parents[$category_id];
				$subcategory_id = $parents_path[count($parents_path)-1];
				$category_header .=": <a href='remove_restriction_action.php?restriction=".$subcategory_id."&type=category'> all </a> <b>&#187;</b> ";
				 
				array_shift ($parents_path);
				
				foreach ($parents_path as $pp){
					$p_node = $category_tree->getNode($pp);
					if($p_node['id'] == $subcategory_id)
						$category_header .=" ".$p_node['name']." ";
					else
						$category_header .=" <a href='add_restriction_action.php?cat_id=$p_node[id]'>$p_node[name]  </a> <b>&#187;</b> ";
				}
				
				$category_id = $subcategory_id ;
			}
			
			$subcategories_html="";
			$node = $category_tree->getNode($category_id);
			$subnodes = $node['nodes'] ;
			foreach($subnodes as $sn)
				$subcategories_html.= " <a href='add_restriction_action.php?cat_id=".$sn['id']."'>".$sn['name']."  </a> (". $sn['count'] .") <br> ";
			
			
		?>
		<table width="100%"  class="categories">
			<tr><th colspan="2" class="categories"><?= $category_header ?></th></tr>
			<tr><td width="50%" valign="top"><?= $subcategories_html ?></td></tr>	
		</table><br>
		<?php 
		} //foreach root_categories
		?> 
     </td>
	 
	 
	 <td valign="top"> <!-- right column with restrictions and results -->

   <table width="100%" class="restrictions">
   <tr>
   <th colspan="2" align="left"  class="restrictions">These terms define your current search:</th>
   </tr>
	<?php
		foreach($search_keywords as $sk){
			echo "<tr>\n";
			echo "<td>";
			echo "<b>Keyword:</b> ". $sk;
			echo "</td>\n";
			echo "<td><a href='remove_restriction_action.php?restriction=".$sk."&type=keyword'>remove</a></td>\n";
			echo "</tr>\n";
		}
	
		foreach($search_categories as $sc){
			$category_parents = $selected_categories[$sc];
			$category_name="";
			$category_path="";
			foreach ($category_parents as $cp){
				$c_node = $category_tree->getNode($cp);
				if(strlen($category_name) == 0){
					$category_name = $c_node['name'];
				}
				else if(strlen($category_path) == 0){
					$category_path = $c_node['name'];
				}
				else{
					$category_path .= " <b>&#187;</b> ".$c_node['name'];
				}
			}
		
			echo "<tr>\n";
				
			echo "<td><b>$category_name:</b> ". $category_path ." </td>\n";
			echo "<td><a href='remove_restriction_action.php?restriction=".$sc."&type=category'>remove</a></td>\n";
			echo "</tr>\n";
		}
	?>

	<tr>
		<th class="restrictions" colspan="2">Found <?= $gCount?> resource for this restrictions.</th>
	</tr>
	</table>

	 <!-- results list  -->
<p>

Result page: 
<?php if ( $page >1 ){ ?>
	<b><a href="search_results.php?count=<?=$count?>&page=<?= ($page - 1)?><?= $qs ?>">previous</a></b> 
<?php } ?>
<?php 
	for ($i = 1; $i <= $pages; $i++) {
		if ($page == $i) 
				echo "<b>$i</b> ";
		else 
				echo "<a href=\"search_results.php?page=$i&$qs\">$i</a> ";
	}
?>
<?php if ( $page < $pages ){ ?>
	<b><a href="search_results.php?count=<?=$count?>&page=<?= ($page + 1)?><?= $qs?>">next</a></b>
<?php } ?>
</p>	 
	 
 
<table width="100%" class="result_set">

<tr>
	<th class="result_set">Resources</a> </th>
</tr>
<?php
	$i = 0;
	foreach($resources as $r){
		$name = $r['name'];
	 	if (strlen($name) == 0) 
	 		$name = "[ undefined ]";
		if ($i % 2 == 1) 
			$cstyle = "list_even"; 
		else 
			$cstyle="";
			
		echo "<tr class='$cstyle'>\n";
		$pos = $from + $i;
		echo "<td class='result_set'><a href='resource/view_resource.php?id=$r[id]&pos=$pos'>$name</a></td>\n";
		echo "</tr>\n";
		$i++;
	}
?>
</table>

<p>
Result page: 
<?php if ( $page >1 ){ ?>
	<b><a href="search_results.php?count=<?=$count?>&page=<?= ($page - 1)?><?= $qs ?>">previous</a></b> 
<?php } ?>
<?php 
	for ($i = 1; $i <= $pages; $i++) {
		if ($page == $i) 
				echo "<b>$i</b> ";
		else 
				echo "<a href=\"search_results.php?page=$i&$qs\">$i</a> ";
	}
?>
<?php if ( $page < $pages ){ ?>
	<b><a href="search_results.php?count=<?=$count?>&page=<?= ($page + 1)?><?= $qs?>">next</a></b>
<?php } ?>

</p>

	 
 <!-- end of right column -->
	  </td>
    </tr>
</table> 
  


<?php include "$DOC_ROOT/common/footer.php"; ?>
</body>
</html>