<?php

/**
 * Collection of user bookmarked resources
 */
class CUserCollection{
	
	//-------------------------------------------------------------------------
	/**
	 * Constructor
	 */
	public function __construct($database, $user){
		
		$this->db = $database;
		$this->user = $user;
	}	

	
	//-------------------------------------------------------------------------
	/**
	 * Get number of resources in collection for given user
	 */
	public function getCount(){

		$sql = "SELECT count(*) FROM user_collection" .
					 "WHERE user='$this->user'";
					 
		$result = $this->db->query($sql);
		$row = $result->fetchRow();
		
		return $row[0];
	}

	
	//-------------------------------------------------------------------------
	/**
	 * Return all resources in collection
	 */
	public function getResources(){

		$sql = "SELECT res_id, name FROM user_collection, resources " .
					 "WHERE res_id=resources.id AND user='$this->user'";
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
		

		$resources = array();
		while($row = $result->fetchRow()) {
			$resource['id'] = $row[0];
			$resource['name'] = $row[1];
			array_push($resources, $resource);
		}		
		
		return $resources;
	}

	
	//-------------------------------------------------------------------------
	/**
	 * Add resource to collection
	 */
	public function addResource($resource_id){

		$sql = "INSERT INTO user_collection SET res_id=$resource_id, user='$this->user'";
					 
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
	}

	
	//-------------------------------------------------------------------------
	/**
	 * Remove resource from collection
	 */
	public function removeResource($resource_id){

		$sql = "DELETE FROM user_collection " . 
					 "WHERE res_id=$resource_id AND user='$this->user'";
					 
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
	}

	
	//-------------------------------------------------------------------------
	/**
	 * Check if resource is in collection
	 */
	public function isIn($resource_id){

		$sql = "SELECT count(*) FROM user_collection " .
					 "WHERE user='$this->user' AND res_id=$resource_id";
					 
		$result = $this->db->query($sql);
		$row = $result->fetchRow();
		
		return ($row[0] > 0);
	}

	
	//---------------------------------------------------------------------------
	// Private members
	/** Database */
	private $db;
	/** user */
	private $user;
}	
?>