<?php
/**
 * This class represents permissions
 */
class CPerm{
	//-------------------------------------------------------------------------
	// Private members

	// ** Permission types */
	private $TYPE = array( 0=>"read", 1=>"write", 2=>"full" );

	// ** Permission objects */	
	private $OBJECT = array( 0=>"Admin app", 1=>"Test" );
	
	// ** Database */
	private $db;

	//-------------------------------------------------------------------------
	/**
	 * Constructor
	 */
	public function __construct($database) {
		$this->db = $database;
	}	

	//-------------------------------------------------------------------------
	/**
	 * Check user's permissions
	 * @return true or false
	 */
	public function hasUserPermission($userId, $objectId, $typeId) {
		$sql = "SELECT * FROM permissions WHERE user_id='$userId' AND object_id='$objectId' AND type_id='$typeId'"; 		
		$res = $this->db->query($sql);

		if (DB::isError($res)) {
			die($res->getMessage());
		}		
		$hasPerm = $res->fetchRow() ? true : false; 

		return $hasPerm;
	}

	//-------------------------------------------------------------------------	
	/**
	 * Get user permissions
	 */
	public function getPermissions($userId) {
		$arr = array();
		$sql = "SELECT object_id, type_id FROM permissions WHERE user_id='$userId' ORDER BY object_id, type_id"; 		
		$res = $this->db->query($sql);

		if (DB::isError($res)) {
			die($res->getMessage());
		}

		while ($row = $res->fetchRow()) {
			$perm['object_id'] = $row[0];
			$perm['type_id'] = $row[1];

			array_push($arr, $perm);			
		}		
		return $arr;
	}

	//-------------------------------------------------------------------------
	/**
	 * Add permission
	 */
	public function addPermission($userId, $objectId, $typeId) {
		$hasPermission = $this->hasUserPermission($userId, $objectId, $typeId);
		if (!$hasPermission) {
			$sql = "INSERT INTO permissions SET user_id='$userId', object_id='$objectId', type_id='$typeId'";
			$res = $this->db->query($sql);
	
			if (DB::isError($res)) {
				die($res->getMessage());
			}
		}
	}

	//-------------------------------------------------------------------------
	/**
	 * Remove permission
	 */
	public function removePermission($userId, $objectId, $typeId) {
		$sql = "DELETE FROM permissions WHERE user_id='$userId' AND object_id='$objectId' AND type_id='$typeId'";
		$res = $this->db->query($sql);

		if (DB::isError($res)) {
			die($res->getMessage());
		}
	}

	//-------------------------------------------------------------------------
	/**
	 * count permissions
	 * @return int
	 */
	public function countUsers() {
		$sql = "SELECT count(*) FROM permissions";	
		$res = $this->db->query($sql);

		if (DB::isError($res)) {
			die($res->getMessage());
		}
		
		$row = $res->fetchRow();
		$count = $row[0];		
		return $count;		
	}

	//-------------------------------------------------------------------------
	/**
	 * Get permission type name
	 * @return array
	 */
	public function getTypes() {
		return $this->TYPE;
	}
	//-------------------------------------------------------------------------		
	/**
	 * Get permission object name
	 * @return array
	 */
	public function getObjects() {
		return $this->OBJECT;
	}
	//-------------------------------------------------------------------------

}
?>