<?php
require_once $CLASSES_ROOT . "odars/dao/resource/cresource.php";

class CNewResourceAction{
	
	//-------------------------------------------------------------------------
	/**
	 * Constructor
	 * 	@database - database connection
	 *  @base_path - content path with resource files
	 *  @data - resource data
	 *
	 */
	public function __construct($database, $base_path, $data){
		$this->db = $database;
		$this->base_path = $base_path;
		$this->data = $data;
	}	

	
	//-------------------------------------------------------------------------
	/**
	 * Execute action
	 */
	public function execute(){

		$id = $this->data['id'];
		$english_name = addslashes($this->data['english_name']);
		$native_name = addslashes($this->data['native_name']);
		$author = addslashes($this->data['author']);
		$remarks = addslashes($this->data['remarks']);

		$path = $this->createPath($id);
		$query = "INSERT INTO resources SET id=$id, name='$english_name', " . 
							"native_name='$native_name', author='$author', date=NOW(), " .
							"file_path='$path', remarks='$remarks'";
		
		$result = $this->db->query($query);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
							
		$resource = new CResource($this->db, $id);

		$resource->updateKeywords($this->data['keywords']);
		$resource->updateCategories($this->data['categories']);
		
	}	
	
	
	//-------------------------------------------------------------------------
	/**
	 * Create resource directory
	 */
	public function createPath($id){

		$path = "a".rand(0,99);
		if(!file_exists($this->base_path.$path))
			mkdir($this->base_path.$path);

		$path .= "/b".rand(0,99);
		if(!file_exists($this->base_path.$path))
			mkdir($this->base_path.$path);
		
		$path .= "/c".rand(0,99);
		if(!file_exists($this->base_path.$path))
			mkdir($this->base_path.$path);
		
		$path .= "/$id";
		if(!file_exists($this->base_path.$path))
			mkdir($this->base_path.$path);
		
		return $path;
	}	
	
	
	//---------------------------------------------------------------------------
	// Private members
	/** Database */
	private $db;
	/** Base file path */
	private $base_path;
	/** Resource data */
	private $data;
}	
?>