<?php

/**
 * Relations between resources
 */
class CResRelations{
	
	//-------------------------------------------------------------------------
	/**
	 * Constructor
	 */
	public function __construct($database, $id){
		
		$this->db = $database;
		$this->id = $id;
	}	


	//-------------------------------------------------------------------------
	/**
	 * Add resource relation 
	 */
	public function addRelation($relation, $object_id ){

		$sql = "INSERT INTO resources_relations " . 
					 "SET source_id = $this->id, relation_id = $relation, dest_id=$object_id ";
					 
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
	}


	//-------------------------------------------------------------------------
	/**
	 * Remove relation 
	 */
	public function removeRelation($relation, $object_id){

		$sql = "DELETE FROM resources_relations " . 
					 "WHERE source_id = $this->id AND relation_id=$relation AND dest_id=$object_id";
					 
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
	}

	//-------------------------------------------------------------------------
	/**
	 * Return all relations
	 */
	public function getRelations(){

		$sql = "SELECT source_id, relation_id, dest_id, rd.name " .
					 "FROM resources_relations AS rr, relation_definition AS rd " .
					 "WHERE rd.id=rr.relation_id AND " .
					 "(source_id=$this->id OR dest_id=$this->id)";
					 
		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
		

		$relations = array();
		$relations['from'] = array();
		$relations['to'] = array();
		while($row = $result->fetchRow()) {
			if($row[0] == $this->id){
				$from['relation_id'] = $row[1];
				$from['resource'] = $row[2];
				$from['relation_name'] = $row[3];
				array_push($relations['from'], $from);
			}
			else{
				$to['relation_id'] = $row[1];
				$to['resource'] = $row[0];
				$to['relation_name'] = $row[3];
				array_push($relations['to'], $to);
			}
		}

		return $relations;
	}

	//-------------------------------------------------------------------------
	/**
	 * Return all relations
	 */
	public function getRelationsList(){

		$sql = "SELECT id, name FROM relation_definition";

		$result = $this->db->query($sql);
		if(DB::isError($result)) 
    	die(__FILE__ . " (" . __LINE__ . ") " . $result->getMessage());
		

		$relations = array();
		while($row = $result->fetchRow()) {
			$rl['id'] = $row[0];
			$rl['name'] = $row[1];
			array_push($relations, $rl);
		}
		return $relations;
	}
	
	
	//---------------------------------------------------------------------------
	// Private members
	/** Database */
	private $db;
	/** resource id */
	private $id;	
}
?>