<?php
/**
 * This file contains some useful functions
 */

	//---------------------------------------------------------------------------
	/**
	* Delete a file, or a folder and its contents
	*
	* @author      Aidan Lister <aidan@php.net>
	* @version     1.0
	* @param       string   $dirname    The directory to delete
	* @return      bool     Returns true on success, false on failure
	*/
	function rmdirr($dirname)
	{
    // Simple delete for a file
    if (is_file($dirname)) {
        return unlink($dirname);
    }

    // Loop through the folder
    $dir = dir($dirname);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }

        // Deep delete directories      
        if (is_dir("$dirname/$entry")) {
            rmdirr("$dirname/$entry");
        } else {
            unlink("$dirname/$entry");
        }
    }

    // Clean up
    $dir->close();
    return rmdir($dirname);
	}
	
	//---------------------------------------------------------------------------
	/**
	* Return the human readable size of a file
	*
	* @param       int    $size   A file size
	* @param       int    $dec    A number of decimal places
	* @author      Martin Benjamin <b.martin@cybernet.ch>
	* @author      Aidan Lister <aidan@php.net>
	* @version     1.0.0
	*/
	function formatFileSize($size, $dec = 1)
	{
    $sizes = array('B', 'KB', 'MB', 'GB');
    $count = count($sizes);
    $i = 0;
    
    while ($size >= 1024 && ($i < $count - 1)) {
        $size /= 1024;
        $i++;
    }

    return round($size, $dec) . ' ' . $sizes[$i];
	}
	
	
?>