<?php
/**
 * This file contains functions which deal with preview
 */


	//-------------------------------------------------------------------------
	/**
	 * Check if it is possible to make preview from given file
	 * @param $input input file name
	 * @param $output output file name (without extension)
	 */
  function canMakePreview($filename){
  
  	$ext = strtolower(substr($filename,strrpos($filename, ".")+1));
  	
  	if(	$ext == "jpg" || $ext == "jpeg" ||
  			$ext == "png" || $ext == "gif")
  	{
  		return true;
  	}
  	
  	return false;
	}
	
	
	//-------------------------------------------------------------------------
	/**
	 * create preview
	 * @param $input input file name
	 * @param $output output file name (without extension)
	 */
  function createPreview($input, $output, $new_w, $new_h){

    $system=explode(".",$input);
    if (preg_match("/jpg|jpeg/",strtolower($system[1]))){
        $src_img=imagecreatefromjpeg($input);
    }
    else if (preg_match("/png/",strtolower($system[1]))){
        $src_img=imagecreatefrompng($input);
    }
    else if (preg_match("/gif/",strtolower($system[1]))){
        $src_img=imagecreatefromgif($input);
    }
    $input_x=imageSX($src_img);
    $input_y=imageSY($src_img);   

    $old_x=imageSX($src_img)/$new_w;
    $old_y=imageSY($src_img)/$new_h;

    if ($old_x >= $old_y) {
        $thumb_w=$new_w;
        $thumb_h=round(imageSY($src_img)/$old_x);
    } else {
        $thumb_w=round(imageSX($src_img)/$old_y);
        $thumb_h=$new_h;
    }

    $dst_img=ImageCreateTrueColor($thumb_w,$thumb_h);
    
		imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$input_x,$input_y);

    imagejpeg($dst_img, $output . ".jpg");
    imagedestroy($dst_img);
    imagedestroy($src_img);
	}

?>